unit msg_thread2;

interface

uses
  System.Classes, System.Messaging, System.SysUtils, System.DateUtils,
  System.Diagnostics;

type
  TTestMessages2 = class(TThread)
  private
    FMessageManager: TMessageManager;
    {Private declarations}
  protected
    procedure Execute; override;
  public

  end;

implementation

//uses
//  tbsLogger;
{TTestMessages}

procedure TTestMessages2.Execute;
var
  iCount: Integer;
  lMessage: TMessage;
  dtStart: TDateTime;
  iMillis: Int64;
  lStopWatch: TStopwatch;
begin
  {Place thread code here}
  FMessageManager := TMessageManager.DefaultManager;
  iCount := 0;
  while not Terminated do
  begin
    inc(iCount);
   // TtbsGCLogger.Send('2 Thread count', iCount.ToString);
    lMessage := TMessage<UnicodeString>.Create('2 Message No ' + iCount.ToString);
    lStopWatch := TStopWatch.StartNew;

    TThread.CreateAnonymousThread(
      procedure()
      begin
        FMessageManager.SendMessage(Self, lMessage, True);
      end).Start;


    //TtbsGCLogger.Send('2 send elapsed', lStopWatch.Elapsed);
    Sleep(1000);
  end;

end;

end.
